import { LogBase, Logger } from '@pnpm/logger';
export declare const progressLogger: Logger<ProgressMessage>;
export interface LoggedPkg {
    rawSpec: string;
    name?: string;
    dependentId?: string;
}
export declare type ProgressMessage = {
    pkgId: string;
    status: 'fetched' | 'installed' | 'dependencies_installed' | 'found_in_store' | 'resolving_content';
} | {
    pkgId: string;
    pkg: LoggedPkg;
    status: 'resolved';
} | {
    pkg: LoggedPkg;
    status: 'resolving' | 'error' | 'installing';
} | {
    pkgId: string;
    status: 'fetching_started';
    size: number | null;
    attempt: number;
} | {
    pkgId: string;
    status: 'fetching_progress';
    downloaded: number;
} | {
    status: 'downloaded_manifest';
    pkgId: string;
    pkgVersion: string;
};
export declare type ProgressLog = {
    name: 'pnpm:progress';
} & LogBase & ProgressMessage;
export declare type Log = ProgressLog;
